##
 # reload.mcfunction
 # greyscale
 #
 # Created by CrazyCowMM.
##

## Items
##  lastHeldItem is used to track the number of the custom item the player last held. This is used to then summon in the correct
##  custom entity at the placed armor stand.
##
##  timeSinceItem is used to reset the lastHeldItem score after a slight delay. This is done in case the player places their
##  last custom item which would normally cause lastHeldItem to be set to 0. It is set back to zero rather quickly in
##  case they place a vanilla armor stand right after although this is impossible in the actual map setting.
scoreboard objectives add lastHeldItem dummy
scoreboard objectives add timeSinceItem dummy

## Rays (both doors and prisms)
##  rayTime is used to check how many recursions a ray has gone through. Rays will despawn after a certain amount
##  of recursions in case they are not killed by other functions
##
##  blocksTraveled is used to track the number of blocks a ray has traveled. This is used in Prisms to make
##  sure that they don't check over 50 blocks. 
scoreboard objectives add rayTime dummy
scoreboard objectives add blocksTraveled dummy
scoreboard objectives add rayCheckTime dummy

## Doors
##  pMotion tracks the players motion so that it can be used to determine the direction used when teleporting through
##  a dimensional door
scoreboard objectives add motionCheckDelay dummy
scoreboard objectives add pMotion dummy

## Walls
scoreboard objectives add wallDespawn dummy

## Levers
##  leverN is used an identifier for each pair of levers. As lever entities are placed their leverN score is incremented
##  appropriatly. It does not matter which world the lever is place in first but make sure you always place them in pairs of two
##
##  leverSProto and leverS are used to track the lever's state. Proto is changed initially then levers check to see if their
##  Proto score is different from their score on leverS. If their Proto value is different it can be assumed that that was
##  the lever that was flipped and as such leverS is updated to that new value for all levers in the pair. This causes the
##  other lever to change states as well.
##
##  leverAmountCheck is used for lever number setting. It checks to see how many levers there are with a certain number. Makes 
##  sure that there is always a pair of levers and never more.
scoreboard objectives add leverN dummy
scoreboard objectives add leverSProto dummy
scoreboard objectives add leverS dummy
scoreboard objectives add leverAmountCheck dummy

## Levels (Mainly for entity spawning)
##  level is used to track the players current level and spawn in the correct entities.
##
##  data is used to store some data used for level spawning like what world the entities are being spawned in.
##
##  connection is essentially used as the main control structure to connect beacons, levers, aether doors and prisms.
##  Objects with the same connection score will be changed each time a lever is flipped, or a beacon is activated. 
##
##  loadTimer determines how long the player waits in the loading screen for dialouge completion
scoreboard objectives add level dummy
scoreboard objectives add data dummy
scoreboard objectives add connection dummy
scoreboard objectives add loadTimer dummy
scoreboard objectives add prisms dummy
scoreboard objectives add resetTimer dummy
scoreboard objectives add credits dummy

scoreboard players set constneg1 data -1